unit u_formPrincipale;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fmod, StdCtrls, ExtCtrls;

type
  TformPrincipale = class(TForm)
    btnLire: TButton;
    btnSystemUpdate: TButton;
    Timer: TTimer;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure btnLireClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
  private
    { Dclarations prives }
    FSound   : FMOD_SOUND;
    FChannel : FMOD_CHANNEL;
  public
    { Dclarations publiques }
  end;

var
  formPrincipale: TformPrincipale;

implementation

{$R *.dfm}

function MyCallBack(
  channel: FMOD_CHANNEL;
  callbacktype: FMOD_CHANNEL_CALLBACKTYPE;
  commanddata1: Pointer;
  commanddata2: Pointer):FMOD_RESULT; stdcall;
begin
  Result := FMOD_OK ;
end;

procedure TformPrincipale.FormCreate(Sender: TObject);
begin
  FSound   := nil;
  FChannel := nil;
end;

procedure TformPrincipale.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#27 then begin Key := #0; Close; end;
end;

procedure TformPrincipale.TimerTimer(Sender: TObject);
var
  isPlaying     : LongBool;
  Res           : FMOD_RESULT;
  PositionMs    : Cardinal;
  SoundLengthMs : Cardinal;
begin
  fmod.FcFMOD_System_Update( PFMODSystem );
  if not Assigned(FSound) then
    Exit;
  if not Assigned(FChannel) then
    Exit;
  { S'assurer qu'on est bien en train de jouer : }
  Res := fmod.FcFMOD_Channel_IsPlaying( FChannel, isPlaying );
  if Res<>FMOD_OK then
    raise Exception.Create('Erreur FcFMOD_Channel_IsPlaying()');
  { Lire la position dans le fichier : }
  Res := fmod.FcFMOD_Channel_GetPosition( FChannel, PositionMs, FMOD_TIMEUNIT_MS);
  if Res<>FMOD_OK then
    raise Exception.Create('Erreur FcFMOD_Channel_GetPosition()');
  { Lire la dure totale du fichier : }
  Res := fmod.FcFMOD_Sound_GetLength( FSound, SoundLengthMs, FMOD_TIMEUNIT_MS);
  if Res<>FMOD_OK then
    raise Exception.Create('Erreur FcFMOD_Sound_GetLength()');
  Caption :=
    Format('Temps : %0.2d:%0.2d:%0.2d / %0.2d:%0.2d:%0.2d',
      [ ((PositionMs div 1000) div 60),
        ((PositionMs div 1000) mod 60),
        ((PositionMs div 10) mod 100),
        ((SoundLengthMs div 1000) div 60),
        ((SoundLengthMs div 1000) mod 60),
        ((SoundLengthMs div 10) mod 100) ] );
end;

procedure TformPrincipale.btnLireClick(Sender: TObject);
var
  Res     : FMOD_RESULT;
begin
  (Sender as TButton).Enabled := False;
  FillChar(FSound, SizeOf(FSound), 0);
  Res := fmod.FcFMOD_System_CreateSound(PFMODSystem,
    PChar('C:\Partage\Olivier\mp3\02 - Cold Hands Warm Heart.mp3'),
    FMOD_CREATESTREAM, nil, FSound );
  if Res = FMOD_OK then
  begin
    fmod.FcFMOD_System_PlaySound(
      PFMODSystem,
      FMOD_CHANNEL_FREE,
      FSound,
      False,
      FChannel);
  end
  else
  begin
    ShowMessage('Erreur ouverture du fichier mp3');
  end;
  Res := fmod.FcFMOD_Channel_SetCallback( FChannel,
    MyCallBack);
  if Res <> FMOD_OK then
    ShowMessage('Erreur fmod.FcFMOD_Channel_SetCallback() ');
  Timer.Enabled := True;
end;

end.
